﻿<!DOCTYPE html>

<!--
o Imports ships-data from the game "To Each His Own" or it's mods
o Table has various display options, can be sorted, filtered and compared

(c) Stumpfl Markus
17.11.2017		Initial Release (copy from "Caribbean Tales" WebApp)
22.11.2017		"v2" - editing/saving the form is possible; lots of bug fixes

Tooltip: (c) http://www.walterzorn.com
-->

<html lang="en">
<head>
	<title>Corsair 5 - Ship Data Extraction Tool</title>
	<meta charset="utf-8">
	<meta http-equiv="Content-Script-Type" content="text/javascript">
	<meta http-equiv="Content-Style-Type" content="text/css">
	<link rel="icon" sizes="128x128" type="image/png" href="img/favicon.png">
	<link rel="prefetch" href="img/pageup.png">	
	<link rel="prefetch" href="img/nation.england.png">	
	<link rel="prefetch" href="img/nation.france.png">	
	<link rel="prefetch" href="img/nation.holland.png">	
	<link rel="prefetch" href="img/nation.pirate.png">	
	<link rel="prefetch" href="img/nation.spain.png">	
	<link rel="stylesheet" type="text/css" media="screen" href="style.css">
	<script type="text/javascript" src="functions.js"></script>
</head>
<body>
<?php
// Ask if the comparison table should be sorted:
if (!empty($_GET)&& !isset ($_GET["Sort"]))
	echo ('<script>AskToSort ();</script>');
?>

<script type="text/javascript" src="tooltip.js"></script>

<img class="top" alt="TOP" onclick="window.scrollTo(0,0);" src="img/pageup.png" onmouseover="Tip('Scroll to top');" onmouseout="UnTip();" />

<div id="Compare">
	<a href="#" onclick="UnTip(); ShowCompare();" onmouseover="Tip('Compare selected ships', ABOVE, true, OPACITY, 100);" onmouseout="UnTip();">COMPARE</a>
</div>

<?php
/* Datenstruktur
Array
(
    [arabellaship] => Array
        (
            [class] => 2
            [maxcaliber] => 24
            [capacity] => 4000
            [cannonsquantity] => 42
            [maxcrew] => 425
            [optcrew] => 340
            [mincrew] => 50
            [speedrate] => 17.25
            [turnrate] => 37.25
            [price] => 67700
            [hp] => 4800
            [canencounter] => true
            [name] => ManOWar
        )

    [barkentine] => Array
        (
            [class] => 4
            [maxcaliber] => 16
            [capacity] => 2000
            [cannonsquantity] => 14
            [maxcrew] => 106
            [optcrew] => 85
            [mincrew] => 30
            [speedrate] => 11.0
            [turnrate] => 40.0
            [price] => 31300
            [hp] => 2000
            [nation.england] => true
            [nation.france] => true
            [nation.spain] => true
            [nation.holland] => true
            [canencounter] => true
            [name] => Frigate
        )
	...
*/
	$DataDir = 'data';
	
	$Include = array (
				"name" => "Ingame Name",
				"class" => "Class",
				"capacity" => "Cargo",
				"hp" => "HP",
				"cannonsquantity" => "# Cannons",
				"maxcaliber" => "Max. Caliber",
				"mincrew" => "Min. Crew",
				"optcrew" => "Opt. Crew",
				"maxcrew" => "Max. Crew",
				"speedrate" => "Speedrate",
				"turnrate" => "Turnrate",
				"price" => "Price",
				"canencounter" => "Can Encounter?",			// alles vor "canencounter" wird zur Column-Auswahl hinzugefügt!
				"nation.england" => "England",
				"nation.france" => "France",
				"nation.spain" => "Spain",
				"nation.holland" => "Holland",
				"nation.pirate" => "Pirate"
				);
				
	$Exclude = array (
				"Boat",
				"QuestShip0",
				"QuestShip1",
				"QuestShip2",
				"QuestShip3",
				"QuestShip4",
				"QuestShip5",
				"QuestShip6",
				"QuestShip7",
				"QuestShip8",
				"Fort");
			
	$Classes = array (
				"- ALL -",
				"Class 1 (Rank >11)",
				"Class 2 (Rank >9)",
				"Class 3 (Rank >7)",
				"Class 4 (Rank >5)",
				"Class 5 (Rank >3)",
				"Class 6",
				"Class 7"
				);
				
	$ColumnsToDisplay = false;
	
	//$ShipNameUnicodePattern = "[\w\d ]{1,25}";
	$ShipNameUnicodePattern = "[\u0020\u002D\u0041-\u005A\u0061-\u007A\u00A0\u00AA\u00B5\u00BA\u00C0-\u00D6\u00D8-\u00F6\u00F8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376-\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0561-\u0587\u05D0-\u05EA\u05F0-\u05F2\u0620-\u064A\u066E-\u066F\u0671-\u06D3\u06D5\u06E5-\u06E6\u06EE-\u06EF\u06FA-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07CA-\u07EA\u07F4-\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u08A0-\u08B4\u08B6-\u08BD\u0904-\u0939\u093D\u0950\u0958-\u0961\u0971-\u0980\u0985-\u098C\u098F-\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC-\u09DD\u09DF-\u09E1\u09F0-\u09F1\u0A05-\u0A0A\u0A0F-\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32-\u0A33\u0A35-\u0A36\u0A38-\u0A39\u0A59-\u0A5C\u0A5E\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2-\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0-\u0AE1\u0AF9\u0B05-\u0B0C\u0B0F-\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32-\u0B33\u0B35-\u0B39\u0B3D\u0B5C-\u0B5D\u0B5F-\u0B61\u0B71\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99-\u0B9A\u0B9C\u0B9E-\u0B9F\u0BA3-\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60-\u0C61\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0-\u0CE1\u0CF1-\u0CF2\u0D05-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D5F-\u0D61\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0E01-\u0E30\u0E32-\u0E33\u0E40-\u0E46\u0E81-\u0E82\u0E84\u0E87-\u0E88\u0E8A\u0E8D\u0E94-\u0E97\u0E99-\u0E9F\u0EA1-\u0EA3\u0EA5\u0EA7\u0EAA-\u0EAB\u0EAD-\u0EB0\u0EB2-\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0EDC-\u0EDF\u0F00\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F\u1050-\u1055\u105A-\u105D\u1061\u1065-\u1066\u106E-\u1070\u1075-\u1081\u108E\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u169A\u16A0-\u16EA\u16F1-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u1820-\u1877\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1950-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u1A00-\u1A16\u1A20-\u1A54\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B83-\u1BA0\u1BAE-\u1BAF\u1BBA-\u1BE5\u1C00-\u1C23\u1C4D-\u1C4F\u1C5A-\u1C7D\u1C80-\u1C88\u1CE9-\u1CEC\u1CEE-\u1CF1\u1CF5-\u1CF6\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2000-\u200A\u2028-\u2029\u202F\u205F\u2071\u207F\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2183-\u2184\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2-\u2CF3\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3000\u3005-\u3006\u3031-\u3035\u303B-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312D\u3131-\u318E\u31A0-\u31BA\u31F0-\u31FF\u3400-\u4DB5\u4E00-\u9FD5\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA61F\uA62A-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6E5\uA717-\uA71F\uA722-\uA788\uA78B-\uA7AE\uA7B0-\uA7B7\uA7F7-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA840-\uA873\uA882-\uA8B3\uA8F2-\uA8F7\uA8FB\uA8FD\uA90A-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF\uA9E0-\uA9E4\uA9E6-\uA9EF\uA9FA-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5-\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB65\uAB70-\uABE2\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40-\uFB41\uFB43-\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]{1,25}";
	
	require_once ('functions.php');
	
// *********************************************************************************
	
// Delete selected Datafile
	if (isset ($_POST["SelectObjectsChoice"]) && $_POST["SelectObjectsChoice"] == "delete")
	{
		global $DataDir;

		foreach ($_POST["Objects"] as $File)
		{
			if (!unlink ($DataDir.'/'.$File))
				echo ('<script type="text/javascript">alert ("Couldn\'t delete the file: ('.$File.')!");</script>');
		}

		DeletePost ();
	}
	
// Import New Ships-File
	if (isset ($_FILES["ShipData"]["tmp_name"]) && isset ($_FILES["ShipNames"]["tmp_name"]) && isset ($_POST["FileDesc"]))
	{
		ImportData ();
	}

// Write Changed Shipdata to File
	if (isset ($_POST["ShipdataFile"]))
	{
		WriteNewShipdata ($_POST, array_keys ($Include));
	}

// Check Data Files
	if (is_dir ($DataDir))
	{
		$handle = opendir($DataDir);
		$o = 0;
		while (false !== ($DataFiles[$o] = readdir($handle)))
		{
			if ($DataFiles[$o] != '.' && $DataFiles[$o] != '..')
				$o++;
		}
		closedir($handle);

		$DataFiles = array_slice ($DataFiles, 0, sizeof($DataFiles)-1);
		sort ($DataFiles);
	}
	else
		$DataFiles = array ();

// Load Shipsfile Form
	echo ('<h1>Corsair 5 / Sea Dogs 5 / To Each His Own</h1>');

	echo ('<abbr onmouseover="Tip(\'<dl><dt>Load Data</dt><dd>locate the #Ships_init.c# and the #common.ini# files in the game directory</dd><dd>select them via the Load-Forms</dd><dd>click the #Load# button</dd><dd>to delete an imported file select it and click the #Delete# button</dd><dt>Sorting</dt><dd>#left-click# a header for primary sort</dd><dd>#right-click# for secondary sort</dd><dd>click again to switch ascending/descending</dd><dt>Display Options</dt><dd>select one or more imported data files</dd><dd>choose if ships that cannot be encountered/bought should be displayed</dd><dd>limit the output to a specific class of ships</dd><dd>select which columns should be displayed</dd><dd>click the #Display# button</dd><dt>Comparing</dt><dd>click the row you want to add to the list</dd><dd>click again to remove it</dd><dd>click the #Compare# button to see the list</dd><dd>click the #Save# button to save this comparison for future use</dd><dd>when pasting this URL you will be asked if you want to keep the sorting (like the ships were added)<br/>&nbsp;&nbsp;&nbsp;&nbsp;or if the list should be sorted alphabetically (via ship names across all files!)</dd></dl>\', TITLE, \'HELP\', OPACITY, 100, CLICKSTICKY, true, CLOSEBTN, true);" onmouseout="UnTip();">Help</abbr> ');
	
	echo ('# <abbr onmouseover="Tip(\'The ship data ingame can differ from these default values! More specifically:<dl><dt>Skills</dt><dd>I am not sure about this, but your skills (and your officers) might change the specs shown in the ships info panel</dd><dt>Upgrades</dt><dd>These really expensive upgrades have a direct impact on the ships performance and specs!</dd></dl>\', TITLE, \'Click to make sticky!\', OPACITY, 100, CLICKSTICKY, true, CLOSEBTN, true);" onmouseout="UnTip();">Differences in ingame data</abbr> ');
	
	if (sizeof ($DataFiles) == 0)
		echo ('<div id="loadfile" class="textshow">');
	else
	{
		echo ('# <abbr onmouseover="Tip(\'Click to hide/show the load-file-form!\', TITLE, \'INFO\');" onmouseout="UnTip();" onclick="ExpandCollapse(\'loadfile\');">Show/Hide Load-Form</abbr> ');
		echo ('# <abbr onmouseover="Tip(\'Click to hide/show the display-form!\', TITLE, \'INFO\');" onmouseout="UnTip();" onclick="ExpandCollapse(\'display\');">Show/Hide Display-Form</abbr>');
		echo ('<div id="loadfile" class="texthide">');
	}
	echo ('<form name="LoadFile" action="index.php" method="POST" enctype="multipart/form-data">');
		echo ('<p class="load">Please select the ships-file <span class="lowlight">(Ships_init.c)</span> and the names-file <span class="lowlight">(common.ini)</span>, as well as a description:<br/>');
		// ships_init.c
		echo ('<input type="file" class="fileupload" name="ShipData" multiple="false" size="50" maxlength="256" accept="text/*.c" onmouseover="Tip(\'Please select the ships-file from the filesystem! <i>(Ships_init.c)</i>\', TITLE, \'Info\');" onmouseout="UnTip();" />');
		// common.ini
		echo ('<input type="file" class="fileupload" name="ShipNames" multiple="false" size="50" maxlength="256" accept="text/*.c" onmouseover="Tip(\'Please select the names-file from the filesystem! <i>(common.ini)</i>\', TITLE, \'Info\');" onmouseout="UnTip();" />');
		echo ('<input type="text" class="filename" name="FileDesc" size="30" maxlength="30" onmouseover="Tip(\'Enter a description/headline for this data! <i>(eg. HorizonMod)</i>\', TITLE, \'Info\');" onmouseout="UnTip();" />');	
		echo ('<input type="button" class="load" Value=" Load " onclick="LoadFileCheck();" onmouseover="Tip(\'Load the selected ships-file.\', TITLE, \'Info\');" onmouseout="UnTip();" />');
		echo ('</p>');
	echo ('</form>');
	echo ('</div>');

	if (sizeof ($DataFiles) == 0)
	{
		echo ('<div class="nodata">no data yet</div>');
		exit ();
	}
	
	// Reset activated?
	if (isset ($_POST["ResetAll"]) && $_POST["ResetAll"] == "true")
		unset ($_POST);

	// Check POST for sort settings
	if (isset ($_POST["SortValue1"]) && $_POST["SortValue1"] != "")
	{
		if ($_POST["SortValue1"][0] == "-")
			$Sort1Type = "Desc";
		else
			$Sort1Type = "Asc";
		$Sort1 = substr ($_POST["SortValue1"], 1);
	}
	else
	{
		$Sort1 = "Name";
		$_POST["SortValue1"] = "+Name";
		$Sort1Type = "Asc";
	}
	
	if (isset ($_POST["SortValue2"]) && $_POST["SortValue2"] != "")
	{
		if ($_POST["SortValue2"][0] == "-")
			$Sort2Type = "Desc";
		else
			$Sort2Type = "Asc";
		$Sort2 = substr ($_POST["SortValue2"], 1);
	}
	else
	{
		$Sort2 = "";
		$_POST["SortValue2"] = "";
		$Sort2Type = "";
	}
	
	// Check POST for files to display
	if (!isset ($_POST["Objects"]) || $_POST["Objects"] == "")
		$_POST["Objects"][0] = $DataFiles[0];

	// Check POST for class filter
	if (!isset ($_POST["ShowClass"]) || $_POST["ShowClass"] == "")
		$ShowClass = 0;
	else
		$ShowClass = $_POST["ShowClass"];

	// Check POST for columns to display
	if (isset ($_POST["DisplayColumns"]))
		$ColumnsToDisplay = $_POST["DisplayColumns"];
	
	echo ('<div id="display" class="textshow">');
		// Display-Form
		echo ('<form name="SelectObjects" action="index.php" method="POST">');
		echo ('<input type="hidden" name="SelectObjectsChoice" size="30" maxlength="30" value="">');
		echo ('<input type="hidden" name="SortValue1" size="30" maxlength="30" value="'.$_POST["SortValue1"].'">');
		echo ('<input type="hidden" name="SortValue2" size="30" maxlength="30" value="'.$_POST["SortValue2"].'">');
		echo ('<table class="display" border="0">');
		echo ('<thead><tr><th onmouseover="Tip(\'Select the file(s) that should be displayed!\', DURATION, 2000, OPACITY, 100);" onmouseout="UnTip();">Files</th><th onmouseover="Tip(\'Select the filter(s) that should be applied!\', DURATION, 2000, OPACITY, 100);" onmouseout="UnTip();">Filter</th><th id="colspanheader" onmouseover="Tip(\'Select the column(s) that should be shown!\', DURATION, 2000, OPACITY, 100);" onmouseout="UnTip();">Columns</th><th>&nbsp;</th></tr></thead><tbody><tr>');
		
		echo ('<td class="one">');			// Files
			echo ('<select class="objects" id="Objects" name="Objects[]" size="5" multiple="multiple" onmouseover="Tip(\'<ul type=disc><li>Select single entries with >STRG<...</li><li>... multiple with >SHIFT<...</li><li>... and all entries wih >STRG + A<</li></ul>\', TITLE, \'Info\');" onmouseout="UnTip();">');

			foreach ($DataFiles as $DataFileName)
			{
				if (in_array ($DataFileName, $_POST["Objects"]))
					echo ('<option selected>'.$DataFileName.'</option>');
				else
					echo ('<option>'.$DataFileName.'</option>');
			}
			echo ('</select>');
		echo ('</td>');

		echo ('<td class="two">');			// Filter
			echo ('Cannot Encounter: <input type="checkbox" class="checkbox" onmouseover="Tip(\'Show ships that cannot be encountered?\', TITLE, \'Info\');" onmouseout="UnTip();" ');
			if (!isset ($_POST["ShowCanEncounter"]) || $_POST["ShowCanEncounter"] == "true")
			{
				echo ('id="ShowCanEncounter" name="ShowCanEncounter" value="true" checked><br/>');
				$ShowCanEncounter = true;
			}
			else
			{
				echo ('id="ShowCanEncounter" name="ShowCanEncounter" value="true"><br/>');
				$ShowCanEncounter = false;
			}
			echo ('<input type="hidden" id="ShowCanEncounterHidden" name="ShowCanEncounter" value="false">');	// wird benötigt zum Übertragen des "ShowCanEncounter = not checked" Values!
			
			echo ('Class: <select name="ShowClass" class="dropdown" nchange="DisplayObject();" onmouseover="Tip(\'Select the class the list should be limited to.\', TITLE, \'Info\');" onmouseout="UnTip();">');
				for ($i=0; $i<sizeof ($Classes); $i++)
				{
					echo ('<option value="'.$i.'"');
					if ($ShowClass == $i)
						echo (' selected');
					echo ('>'.$Classes[$i].'</option>');
				}
			echo ('</select><br/>');
			
			echo ('<b>Make Writeable</b>: <input type="checkbox" class="checkbox" onchange="MakeWritableSubmit();" onmouseover="Tip(\'Makes the whole table writeable!\', TITLE, \'Info\');" onmouseout="UnTip();" ');
			if (!isset ($_POST["MakeWriteable"]) || $_POST["MakeWriteable"] == "false")
			{
				echo ('id="MakeWriteable" name="MakeWriteable" value="true"><br/>');
				$MakeWriteable = false;
			}
			else
			{
				echo ('id="MakeWriteable" name="MakeWriteable" value="true" checked><br/>');
				$MakeWriteable = true;
			}
		echo ('</td>');
		
		echo ('<td class="three">');		// Columns
			$i = 0;
			$Modulo = 4;
			$NumCols = 1;
			
			foreach ($Include as $Column => $ColumnName)
			{
				echo ($ColumnName.': <input type="checkbox" class="checkbox" name="DisplayColumns[]"');
				if ($ColumnsToDisplay === false || in_array ($Column, $ColumnsToDisplay))
					echo ('checked ');
				echo ('value="'.$Column.'" onmouseover="Tip(\'Displays this column if enabled!\');" onmouseout="UnTip();" /><br/>');
				
				$i++;
				
				if (($i%$Modulo) == 0)
				{
					echo ('</td><td class="three">');
					$NumCols++;
				}
			}
			
			// Update header colspan			
			echo ('<script>document.getElementById("colspanheader").colSpan = "'.$NumCols.'";</script>');
			// Needed to be able to reset the form via JS
			echo ('<input type="hidden" name="ResetAll" value="false">');
		echo ('</td>');
		echo ('<td class="four">');
			echo ('<input type="button" class="button" value="  Display  " onclick="DisplayObject();" onmouseover="Tip(\'Display the selected entries.\', TITLE, \'Info\');" onmouseout="UnTip();" /><br/>');
			echo ('<input type="button" class="button" name="DelObj" value="   Delete   " onclick="DeleteObject();" onmouseover="Tip(\'Delete the <u>selected</u> entries.\', TITLE, \'Info\');" onmouseout="UnTip();" /><br/>');
			echo ('<input type="button" class="button" name="ResetDisplay" value="   Reset   " onclick="DelPost();" onmouseover="Tip(\'Clear the display options.\', TITLE, \'Info\');" onmouseout="UnTip();" />');
		echo ('</td>');
		echo ('</tr></tbody></table></form>');
	echo ('</div>');


// Show Content
	foreach ($_POST["Objects"] as $Selected)
	{
		$Data = LoadData ($Selected);

		if ($Sort2 == "")
			$Data = SortDataBy ($Data, $_POST["SortValue1"]);
		else
			$Data = SortDataBy ($Data, $_POST["SortValue1"], $_POST["SortValue2"]);
		
		if ($MakeWriteable)
		{
			echo ('<form name="'.$Selected.'" action="index.php" method="POST" nctype="multipart/form-data" onsubmit="return confirm(\'Really submit the data?\')">');
			echo ('<h2>'.$Selected.'<input type="button" class="button" value="Reset" style="margin-left:10px;" onclick="if (confirm(\'Really reset the whole form?\')){this.form.reset();}" onmouseover="Tip(\'Reset the form data to the default (=loaded) values!\', TITLE, \'Info\', OPACITY, 100);" onmouseout="UnTip();"><input type="submit" class="button" value="Submit" style="margin-left:10px;" onmouseover="Tip(\'Write the data to file?\', TITLE, \'Info\', OPACITY, 100);" onmouseout="UnTip();"></h2>');
			echo ('<input type="hidden" name="ShipdataFile" value="'.$Selected.'">');		// Form, Shipdata, File
		}
		else
			echo ('<h2>'.$Selected.'</h2>');

		echo ('<table class="ships">');

		// Headers
		echo ('<thead><tr id="Header" class="header">');
			if ($Sort1 == "Name")
				echo ('<td id="highlighted1" class="'.$Sort1Type.'" name="Name" onclick="DisplayObject (this, \'\');" onmouseover="Tip(\'Click again to switch ascending/descending order!\', DURATION, 2000, OPACITY, 100);" onmouseout="UnTip();">Name</td>');
			else if ($Sort2 == "Name")
				echo ('<td id="highlighted2" class="'.$Sort2Type.'" name="Name" oncontextmenu="DisplayObject (\'\', this); return false;" onmouseover="Tip(\'Click again to switch ascending/descending order!\', DURATION, 2000, OPACITY, 100);" onmouseout="UnTip();">Name</td>');
			else
				echo ('<td class="clickable" name="Name" onclick="DisplayObject (this, \'\');" oncontextmenu="DisplayObject (\'\', this); return false;" onmouseover="Tip(\'Leftclick: primary sorting column<br/>Rightclick: secondary sorting column\', DURATION, 2000, OPACITY, 100);" onmouseout="UnTip();">Name</td>');
			
			foreach ($Include as $Type => $TypeName)
			{
				if ($ColumnsToDisplay === false || in_array ($Type, $ColumnsToDisplay))
				{
					if ($Type == $Sort1)
						echo ('<td id="highlighted1" class="'.$Sort1Type.'" name="'.$Type.'" onclick="DisplayObject (this, \'\');" onmouseover="Tip(\'Click again to switch ascending/descending order!\', DURATION, 2000, OPACITY, 100);" onmouseout="UnTip();">'.$TypeName.'</td>');
					else if ($Type == $Sort2)
						echo ('<td id="highlighted2" class="'.$Sort2Type.'" name="'.$Type.'" oncontextmenu="DisplayObject (\'\', this); return false;" onmouseover="Tip(\'Click again to switch ascending/descending order!\', DURATION, 2000, OPACITY, 100);" onmouseout="UnTip();">'.$TypeName.'</td>');
					else
						echo ('<td class="clickable" name="'.$Type.'" onclick="DisplayObject (this, \'\');" oncontextmenu="DisplayObject (\'\', this); return false;" onmouseover="Tip(\'Leftclick: primary sorting column<br/>Rightclick: secondary sorting column\', DURATION, 2000, OPACITY, 100);" onmouseout="UnTip();">'.$TypeName.'</td>');
				}
			}
		echo ('</thead></tr><tbody>');

		// Data
		foreach ($Data as $ShipName => $ShipData)
		{
			if (($ShowCanEncounter == true || $ShipData["canencounter"] != "false") && ($ShowClass == 0 || $ShowClass == $ShipData['class']))
			{
				// Daten des Schiffes gleich ausgeben wie "Header"
				$ShipData = array_merge (array_fill_keys (array_keys ($Include), ''), $ShipData);

				if ($MakeWriteable)
					echo ('<input type="hidden" name="ShipdataID[]" value="'.$ShipName.'">');		// Form, Shipdata, Shipid

				echo ('<tr class="highlight"><th style="cursor:pointer;" onmouseover="Tip(\'Click here to add/remove from the comparison list!\', DURATION, 1300, OPACITY, 100);" onmouseout="UnTip();" onclick="SwitchCompare (this.parentElement, \''.$Selected.'\')">'.$ShipName.'</th>');
				foreach ($ShipData as $Key => $Value)
				{
					if ($ColumnsToDisplay === false || in_array ($Key, $ColumnsToDisplay))
					{
						if ($Key == "canencounter")
						{
							echo ('<td onmouseover="Tip(\''.$Include[$Key].'\', DURATION, 1300, OPACITY, 100);" onmouseout="UnTip();">');
							if ($MakeWriteable)
							{
								echo ('<select name="'.$Key.'[]" class="shipdata">');
								echo ('<option value="true">Yes</option><option value="false"');
								if ($Value=="false")
									echo ('selected');
								echo ('>No</option></select>');
							}
							else
								echo ((($Value=="true")?"Yes":"No"));
							echo ('</td>');
						}
						else if (stristr ($Key, "nation") !== false)
						{
							echo ('<td onmouseover="Tip(\'<img src=img/'.$Key.'.png height=25>\', TITLE, \''.$Include[$Key].'\', DURATION, 1300, OPACITY, 100);" onmouseout="UnTip();">');
							if ($MakeWriteable)
							{
								echo ('<select name="'.$Key.'[]" class="shipdata">');
								echo ('<option value="true">Yes</option><option value="false"');
								if ($Value=="false" || $Value=="")
									echo ('selected');
								echo ('>No</option></select>');
							}
							else
							{
								if ($Value == "" || $Value == "false")
									echo ('-');
								else
									echo ('<img src=img/'.$Key.'.png height=25 />');
							}
							echo ('</td>');
						}
						else if ($Key == "name")
						{
							echo ('<td onmouseover="Tip(\'Valid are letters, numbers and spaces (max. 25)\', TITLE, \''.$Include[$Key].'\', DURATION, 1300, OPACITY, 100);" onmouseout="UnTip();">');
							if ($MakeWriteable)
								echo ('<input type="text" name="'.$Key.'[]" pattern="'.$ShipNameUnicodePattern.'" required class="shipdata" value="'.$Value.'">');
							else
								echo ($Value);
							echo ('</td>');
						}
						else if ($Key == "class")
						{
							echo ('<td onmouseover="Tip(\'Valid: 1 - 6\', TITLE, \''.$Include[$Key].'\', DURATION, 1300, OPACITY, 100);" onmouseout="UnTip();">');
							if ($MakeWriteable)
								echo ('<input type="number" name="'.$Key.'[]" min="1" max="6" size="1" required class="shipdata" value="'.$Value.'">');
							else
								echo ($Value);
							echo ('</td>');
						}
						else
						{
							echo ('<td onmouseover="Tip(\'Valid: any number\', TITLE, \''.$Include[$Key].'\', DURATION, 1300, OPACITY, 100);" onmouseout="UnTip();">');
							if ($MakeWriteable)
								echo ('<input type="number" name="'.$Key.'[]" size="'.strlen($Value).'" required class="shipdata" value="'.$Value.'">');
							else
								echo ($Value);
							echo ('</td>');
						}
					}
				}
				echo ('</tr>');
			}
		}
		echo ('</tbody></table>');
		if ($MakeWriteable)
			echo ('</form>');
	}

	
// Compare TABLE (empty)
	echo ('<div id="DivCompare">');
		echo ('<h2>Comparison</h2>');
		
		echo ('<table class="ships" id="TableCompare">');
		
		// Show Saved Comparison
		if (!empty($_GET))
		{
			ShowSavedCompare ($_GET);
		}
			
		echo ('</table><div>');
		echo ('<span onclick="SaveCompare();" onmouseover="Tip(\'Click to save the comparison (by URL)!\');" onmouseout="UnTip();">> save <</span>');		
		echo ('<span onclick="HideCompare();" onmouseover="Tip(\'Click to hide comparison!\');" onmouseout="UnTip();">> close <</span>');		
	echo ('</div></div>');
	?>
</body>
</html>
